
#ifdef WIN32
	#include <windows.h>
	#include <mmsystem.h>
	#pragma comment(lib, "winmm.lib")
	#pragma comment(lib, "Irrlicht.lib")
#endif

#include <irrlicht.h>


using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;

#ifdef WIN32
	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
#else
	int main()
#endif
{
	IrrlichtDevice *device  = createDevice(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,0);
	IVideoDriver *driver    = device->getVideoDriver();
	ISceneManager* smgr     = device->getSceneManager();

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	//Jݒ
	smgr->addCameraSceneNode(0, vector3df(0,0,-5), vector3df(0,0,0));//ʏJ

	//WCXeBbNݒ
	JOYINFOEX joyinfo;
	MMRESULT result;
	int pos;
	if(joyGetNumDevs() == 0)
		return -1;//foCXȂ
	if(joyGetPosEx(JOYSTICKID1, &joyinfo) == JOYERR_UNPLUGGED)
		return -2;//ڑȂ

	//ꉞ擾Zbg
	joyinfo.dwSize    = sizeof (JOYINFOEX);
	joyinfo.dwFlags   = JOY_RETURNALL;


	//tHgݒ
	IGUIEnvironment *Env = device->getGUIEnvironment(); 
	IGUIFont* Font = Env->getFont("font.bmp");
	unsigned short mess[64];

	while(device->run())
	{
		driver->beginScene(true,true,0xFF6060FF);

		result = joyGetPosEx(JOYSTICKID1, &joyinfo);
		if(result == JOYERR_NOERROR)
		{
			swprintf(mess, 32, L"dwButtons:0x%04X", joyinfo.dwButtons);
			Font->draw(mess,rect<s32>(0,0,0,0),0xFFFFFFFF);    
			swprintf(mess, 32, L"dwXpos   :0x%04X", joyinfo.dwXpos);
			Font->draw(mess,rect<s32>(0,16,0,0),0xFFFFFFFF);    
			swprintf(mess, 32, L"dwYpos   :0x%04X", joyinfo.dwYpos);
			Font->draw(mess,rect<s32>(0,32,0,0),0xFFFFFFFF);    
			swprintf(mess, 32, L"dwZpos   :0x%04X", joyinfo.dwZpos);
			Font->draw(mess,rect<s32>(0,48,0,0),0xFFFFFFFF);    
			swprintf(mess, 32, L"dwRpos   :0x%04X", joyinfo.dwRpos);
			Font->draw(mess,rect<s32>(0,64,0,0),0xFFFFFFFF); 
			
			//ANALOG[hł̕L[
			pos = 0x00;//CENTER
			if ( joyinfo.dwPOV != JOY_POVCENTERED ) {
				if ( (joyinfo.dwPOV > JOY_POVLEFT) || (joyinfo.dwPOV < JOY_POVRIGHT) ) {
					pos |= 0x01;//UP
				}
				if ( (joyinfo.dwPOV > JOY_POVFORWARD) && (joyinfo.dwPOV < JOY_POVBACKWARD) ) {
					pos |= 0x02;//RIGHT
				}
				if ( (joyinfo.dwPOV > JOY_POVRIGHT) && (joyinfo.dwPOV < JOY_POVLEFT) ) {
					pos |= 0x04;//DOWN
				}
				if ( joyinfo.dwPOV > JOY_POVBACKWARD ) {
					pos |= 0x08;//LEFT
				}
			}
			swprintf(mess, 32, L"dwPOV    :0x%04X", pos);
			Font->draw(mess,rect<s32>(0,80,0,0),0xFFFFFFFF); 

			swprintf(mess, 32, L"dwSize   :0x%04X", joyinfo.dwSize);
			Font->draw(mess,rect<s32>(0,96,0,0),0xFFFFFFFF); 

			swprintf(mess, 32, L"dwFlags  :0x%04X", joyinfo.dwFlags);
			Font->draw(mess,rect<s32>(0,112,0,0),0xFFFFFFFF); 

			swprintf(mess, 32, L"dwNum    :0x%04X", joyinfo.dwButtonNumber);
			Font->draw(mess,rect<s32>(0,128,0,0),0xFFFFFFFF); 

		}

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	driver->drop();

	return 0;
}
